//  *****************************************************************************
//   						main.c
// 
//              Demonstracny program pre dosku KTK ARM7
//
//              Ukazka prace Watchdogu
//
//  *****************************************************************************

// Hlavickove subory
#include "board.h"


//  *******************************************************
//  Kratke cakanie (cca 450 us)
//  *******************************************************
void cakaj(void)
{ unsigned int cas;
 
  for(cas=0; cas < MCK/20000; cas++);
}

//  *******************************************************
//                Hlavny program
//  *******************************************************
int main(void) 
{ int ii;

  //******************* Uvodna inicializacia *******************

  // Povolenie Resetu - minimalna dlzka 960 us
  AT91C_BASE_RSTC->RSTC_RMR = AT91C_RSTC_URSTEN | (0x4<<8) | (unsigned int)(0xA5<<24);
	
  //******************* Inicializacia portu A ******************

  // Povolenie hodin pre PIOA
  AT91C_BASE_PMC->PMC_PCER = (unsigned int) 1 << AT91C_ID_PIOA; 
	
  // konfiguracia jednotlivych pinov
  // vstupne piny
  AT91C_BASE_PIOA->PIO_ODR = S2;
  // vystupne piny
  AT91C_BASE_PIOA->PIO_OER = D1;
  // povolenie Pull-Up rezistoru
  AT91C_BASE_PIOA->PIO_PPUER = S2;
  // povolenie vsetkych nakonfigurovanych pinov
  AT91C_BASE_PIOA->PIO_PER = D1 | S2;

  //******************* Hlavna cast programu *******************

  // zapnutie LED na cca 1s
  AT91C_BASE_PIOA->PIO_SODR = D1;
  for(ii=0;ii<2200;ii++)
    cakaj();
  AT91C_BASE_PIOA->PIO_CODR = D1;

  // inicializacia Watchdogu - povolenie resetu procesora a nastavenie periody na 1s 
  // (x*128/SCK = 256*128/32768 = 1)
  AT91C_BASE_WDTC->WDTC_WDMR = AT91C_WDTC_WDRSTEN | (256 << 16) | 256;
  
  // nekonecna slucka
  while(1)
  { // reset Watchdogu - hornych 8 bitov musi byt 0xA5
    AT91C_BASE_WDTC->WDTC_WDCR = AT91C_WDTC_WDRSTT | (0xA5 << 24);
    
    // kontrola stlacenia S2  
    if(!(AT91C_BASE_PIOA->PIO_PDSR & S2))
    { cakaj();                                  // potlacenie zakmitov
      // cakanie na pustenie S2
      while(!(AT91C_BASE_PIOA->PIO_PDSR & S2))  // kontrola, ci je S2 v log.0
        cakaj();                                // potlacenie zakmitov
    }
  }
}
